# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

class BoardsController < ApplicationController
  layout 'base_projects'#by young
  default_search_scope :messages
  before_filter :find_project_by_project_id, :find_board_if_available, :except => [:join_to_org_subfields]
  before_filter :authorize, :except => [:new, :show, :create, :index, :join_to_org_subfields]
  accept_rss_auth :index, :show
  

  helper :sort
  include SortHelper
  helper :watchers
  helper :project_score
  helper :attachments
  include PraiseTreadHelper
  def index
    #modify by nwb
    @flag = params[:flag] || false
    if @project
      if !@project.is_public? && !User.current.member_of?(@project) && !User.current.admin?
        render_403
      else
        @boards = @project.boards.includes(:last_message => :author).all
        @boards = [] << @boards[0] if @boards.any?
        if @boards.size == 1
          @board = @boards.first
          show and return
        end
        render :layout => false if request.xhr?
      end
    elsif @course
      if (User.current.admin? || @course.is_public == 1 || (@course.is_public == 0 && User.current.member_of_course?(@course)))
        @boards = @course.boards.includes(:last_message => :author).all
        if @course.boards.empty?
          @board = @course.boards.build
          @board.name = " #{l(:label_borad_course) }"
          @board.description = @course.name.to_s
          @board.project_id = -1
          if @board.save
            @boards = @course.boards.includes(:last_message => :author).all
          end
        end
        unless @course.boards.empty?
          @board = @course.boards.first
        end
        show and return
      else
        render_403
      end
    end
  end

  def show
    # 讨论区消息状态更新（已读和未读）
    @order, @b_sort,@type = params[:order] || 1, params[:sort] || 1, params[:type] || 1

    #确定 sort_type 1升序 2 降序
    if @order.to_i == @type.to_i
      @b_sort = @b_sort.to_i == 1 ? 2 : 1
    else
      @b_sort = 2
    end

    sort_name = "updated_on"

    sort_type = @b_sort == 1 ? "asc" : "desc"

    if @project
      ForgeMessage.where("user_id =? and project_id =? and viewed =?", User.current.id, @project.id, 0).update_all(:viewed => true)
      # 更新@消息为已读
      # 注释掉这句是因为和上面的方法代码重复，一个类型的消息，已经更新就不需要再更新
      # @project.boards.each do |board|
      #   board.messages.each do |m|
      #     User.current.at_messages.unviewed('Message', m.id).each {|x| x.viewed!}
      #   end
      # end
    elsif @course
      CourseMessage.where("user_id =? and course_id =? and viewed =?", User.current.id, @course.id, 0).update_all(:viewed => true)
    end

    # sort_init 'updated_on', 'desc'
    # sort_update 'created_on' => "#{Message.table_name}.created_on",
    #             'replies' => "#{Message.table_name}.replies_count",
    #             'updated_on' => "COALESCE(last_replies_messages.created_on, #{Message.table_name}.created_on)"

    @is_new = params[:is_new]
    @topic_count = @board ? @board.topics.count : 0
    if @project
      if @board
        @topic_count = @board.topics.count();
        @topic_pages = 0#(params[:page] ? params[:page].to_i + 1 : 0) *10
        @topics = @board.topics.reorder("#{Message.table_name}.sticky DESC, COALESCE(last_replies_messages.created_on, #{Message.table_name}.created_on) #{sort_type}").
            offset(@topic_pages).includes(:last_reply).
            preload(:author, {:last_reply => :author}).all();
      else
        @topics = [];
      end
    elsif @course
      if (@board)
        @topic_count = @board.topics.count();
        @topic_pages = 0 #(params[:page] ? params[:page].to_i + 1 : 0) *10
        @topics = @board.topics.reorder("#{Message.table_name}.sticky DESC, COALESCE(last_replies_messages.created_on, #{Message.table_name}.created_on) #{sort_type}").offset(@topic_pages).includes(:last_reply).preload(:author, {:last_reply => :author}).all();
      else
        @topics = [];
      end
    end

    #根据 赞+回复数排序
    if @order.to_i == 2
      @type = 2
      @topics.each do |topic|
        topic[:infocount] = get_praise_num(topic) + (topic.parent ? topic.parent.children.count : topic.children.count)
        if topic[:infocount] < 0
          topic[:infocount] = 0
        end
      end
      @b_sort == 1 ? @topics = @topics.sort{|x,y| x[:infocount]  <=> y[:infocount] } : @topics = @topics.sort{|x,y| y[:infocount]  <=> x[:infocount] }
      @topics = sort_by_sticky @topics
      @topics = sortby_time_countcommon_hassticky @topics,sort_name
    else
      @type = 1
    end

    #分页
    @limit = 15
    @is_remote = true
    @atta_count = @topics.count
    @atta_pages = Paginator.new @atta_count, @limit, params['page'] || 1
    @offset ||= @atta_pages.offset
    @topics = paginateHelper @topics,@limit

    @page = params[:page] ? params[:page].to_i + 1 : 0
    @message = Message.new(:board => @board)
    #modify by nwb
    if (params[:page] || params[:order])
      respond_to do |format|
        format.js{render "show.js.erb"}
      end
    else
      respond_to do |format|
        format.js
        format.html {
          if @project
            render :action => 'show', :layout => 'base_projects'
          elsif @course
            @params=params
            render :action => 'show', :layout => 'base_courses'
          end
        }
        format.atom {
          @messages = @board.messages.
              reorder('created_on DESC').
              includes(:author, :board).
              limit(Setting.feeds_limit.to_i).
              all
          if @project
            render_feed(@messages, :title => "#{@project}: #{@board}")
          elsif @course
            render_feed(@messages, :title => "#{@course}: #{@board}")
          end
        }
      end
    end
  end

  def new
    @board = @project.boards.build
    @board.safe_attributes = params[:board]
    if @project.project_type == 1
      render :layout => 'base_courses'
    end
  end

  def create    
    @board = @project.boards.build
    @board.safe_attributes = params[:board]
    
    if @board.save
      flash[:notice] = l(:notice_successful_create)
      #Modified by young
      #redirect_to_settings_in_projects
      redirect_to project_board_url(@project, @board)
      #Ended by young
    else
      render :action => 'new'
    end
  end

  def edit
    if @project.project_type == 1
      render :layout => 'base_courses'
    end
  end

  def update
    @board.safe_attributes = params[:board]
    if @board.save
      redirect_to_settings_in_projects
    else
      render :action => 'edit'
    end
  end

  def destroy
    @board.destroy
    redirect_to_settings_in_projects
  end

  def join_to_org_subfields
    if params[:id]
      @board = Board.find(params[:id])
      @org_subfield_ids = params[:org_subfield_ids]
      @org_subfield_ids.each do |id|
        OrgSubfieldBoard.create(:org_subfield_id => id.to_i, :board_id => params[:id].to_i)
      end
    end
  end

private
  def redirect_to_settings_in_projects
    redirect_to settings_project_url(@project, :tab => 'boards')
  end

  def find_board_if_available
    if @project
      @board = @project.boards.find(params[:id]) if params[:id]
    elsif @course
      @board = @course.boards.find(params[:id]) if params[:id]
    end
  rescue ActiveRecord::RecordNotFound
    render_404
  end
end
